unit RobotViewerClass;

interface

uses

  GLScene, GLObjects, EtatClass, GLWin32Viewer, GLMisc, GLGeomObjects, Jpeg,
  Graphics, SysUtils;

type

// ------------ Mise en forme de la classe -------------------------------------
TRobotViewer = class

  constructor Create(S:TGLCylinder; A1:TGLCylinder; A2:TGLCylinder; P:TGLCylinder; D1:TGLDummyCube; D2:TGLDummyCube; GLSC:TGLSceneViewer);
  destructor Destroy;

private

  // -- Les choses pour le GLScene --
  Socle: TGLCylinder;
  Articul1: TGLCylinder;
  Articul2: TGLCylinder;
  Poignet: TGLCylinder;
  Doigt1: TGLDummyCube;
  Doigt2: TGLDummyCube;
  GLSViewer: TGLSceneViewer;
  // -- Les Mthodes --
  procedure save_image();

public

  // -- Les Mthodes --
  procedure setEtat(Etat:TEtat);

end;


// ------------ Fin de la mise en forme ----------------------------------------

implementation
uses unit1;
// ------------ Implementation des methodes de TRobotViewer --------------------
  constructor TRobotViewer.Create(S:TGLCylinder; A1:TGLCylinder; A2:TGLCylinder; P:TGLCylinder; D1:TGLDummyCube; D2:TGLDummyCube; GLSC:TGLSceneViewer);
  begin
    Socle:=S;
    Articul1:=A1;
    Articul2:=A2;
    Poignet:=P;
    Doigt1:=D1;
    Doigt2:=D2;
    GLSViewer:=GLSC;
  end;

  destructor TRobotViewer.Destroy;
  begin
   { Socle := nil;
    Articul1 := nil;
    Articul2 := nil;
    Poignet := nil;
    Doigt1 := nil;
    Doigt2 := nil;}
    Socle.Free;
    Articul1.Free;
    Articul2.Free;
    Poignet.Free;
    Doigt1.Free;
    Doigt2.Free;
  end;

// ------------ Procedures Priv------------------------------------------------
  {Pour la visualisation sur internet, sauvegarde la scene de GLscene dans un
   fichier du format JPEG}
  procedure TRobotViewer.save_image();


  begin

   bmp:=TBitmap.Create;
    bmp.PixelFormat:=pf32bit;
    bmp.Height:=400;
    bmp.Width:=400;




       GLSViewer.Buffer.RenderToBitmap(bmp,100);
       jpg:=TJpegImage.Create;
    jpg.Assign(bmp);
    jpg.CompressionQuality:=80;

    {Effacer la dernire temp}
    DeleteFile(Chemin+'robottmp.jpg');
    {Sauvegarder le nouveau}
    jpg.SaveToFile(Chemin+'robottmp.jpg');
    {Effacer le buffer du JPEG}
   jpg.Free;
    {Effacer la dernire}
    DeleteFile(chemin+'robot.jpg');
    {rnomer le temp}
    RenameFile(chemin+'robottmp.jpg',chemin+'robot.jpg');
    {Effacer le buffer du BMP}
    bmp.free;   //.FreeImage
  end;

// ------------ Procedures Publique --------------------------------------------
  {Modifier la visualisation en 3D avec les valeurs des moteurs}
  procedure TRobotViewer.setEtat(Etat:TEtat);
  begin

    Doigt1.PitchAngle:= - Etat.GetPinceValeur;
    Doigt2.PitchAngle:= Etat.GetPinceValeur;
    socle.TurnAngle := Etat.GetSocleValeur;
    Articul1.TurnAngle :=  - Etat.GetEpauleValeur;
    Articul2.TurnAngle := - Etat.GetCoudeValeur;
    Poignet.TurnAngle := Etat.GetPoignetValeur;

    save_image();

  end;

end.
